*相関0.4の変数XとYを作成する
*XYはともに標準正規分布とする

clear
set obs 10000
set seed 1

*最初に変数xの乱数を作成する
gen double x=0
forvalues i = 1(1)10000 {
             replace x = rnormal() in `i'
        }
		
*条件付き分布を利用してyの乱数を作成する
gen double y=0

forvalues j = 1(1)10000 {
             replace y = sqrt(1-0.4^2)*rnormal()+0.4*x in `j'
        }

corr x y
*rho=0.4087

*5000個の欠損値x2をつくる
gen double x2=x
replace x2=. if _n>5000

reg x2 y
predict double x2_hat
predict u,resid

*5000個を代入したx3をつくる
gen double x3=x2
replace x3=x2_hat if _n>5000

*相関が強すぎる
*rho=0.543
corr x3 y

*残差の標準偏差を調べる
su u 
gen double x4=x3
replace x4=x3+r(sd)*rnormal() if _n>5000
*残差の不確実性を利用する
corr x4 y
*rho=0.4143





		